<template>
    <v-row>
        <v-col>
            <v-card>
                <data-table
                    v-model="items"
                    endpoint="api/coupons"
                    :title="$tc('coupon', 2)"
                    :headers="headers"
                    :search-label="searchLabel"
                    :force-fetch.sync="forceReload"
                >
                    <template v-slot:buttons>
                        <v-btn
                            @click="createDialog = true"
                            color="primary"
                        >
                            <v-icon class="medium" color="white" left>mdi-plus</v-icon>
                            {{ $tc('coupon', 1) }}
                        </v-btn>
                    </template>

                    <template v-slot:item="{ item, index }">
                        <tr>
                            <td>{{ item.name }}</td>
                            <td>{{ item.code }}</td>
                            <td>
                                <v-chip
                                    :color="item.enabled ? 'success' : 'error'"
                                    text-color="white"
                                    label
                                >
                                    {{ item.enabled ? $t('enabled') : $t('disabled') }}
                                </v-chip>
                            </td>
                            <td>
                                <v-menu
                                    :close-on-content-click="false"
                                    offset-y
                                    bottom
                                >
                                    <template v-slot:activator="{ on, attrs }">
                                        <v-btn
                                            color="primary"
                                            dark
                                            icon
                                            v-bind="attrs"
                                            v-on="on"
                                        >
                                            <v-icon>mdi-dots-horizontal</v-icon>
                                        </v-btn>
                                    </template>
                                    <v-list dense>
                                        <v-list-item>
                                            <v-btn
                                                @click="openEditDialog(item)"
                                                class="text-capitalize"
                                                color="primary"
                                                text
                                                block
                                            >
                                                <v-icon left>mdi-pencil</v-icon>
                                                {{ $t('edit') }}
                                            </v-btn>
                                        </v-list-item>
                                        <v-list-item>
                                            <v-btn
                                                @click="openDeleteDialog(item)"
                                                class="text-capitalize"
                                                color="error"
                                                text
                                                block
                                            >
                                                <v-icon left>mdi-delete</v-icon>
                                                {{ $t('delete') }}
                                            </v-btn>
                                        </v-list-item>
                                    </v-list>
                                </v-menu>
                            </td>
                        </tr>
                    </template>
                </data-table>
            </v-card>
        </v-col>

        <v-dialog
            v-if="createDialog"
            v-model="createDialog"
            width="400"
        >
            <v-card>
                <v-card-title class="primary white--text">
                    {{ $t('create_', [$tc('coupon', 1)] )}}
                </v-card-title>
                <v-card-text class="pt-2">
                    <coupon-create-form
                        :loading="loading"
                        @validated="createCoupon"
                    ></coupon-create-form>
                </v-card-text>
            </v-card>
        </v-dialog>

        <v-dialog
            v-if="editing"
            v-model="editDialog"
            @click:outside="closeEditDialog"
            width="400"
        >
            <v-card>
                <v-card-title class="primary white--text">
                    {{ $t('edit_', [$tc('coupon', 1)] )}}
                </v-card-title>
                <v-card-text class="pt-2">
                    <coupon-edit-form
                        v-model="editing"
                        :loading="loading"
                        @validated="editCoupon"
                    ></coupon-edit-form>
                </v-card-text>
            </v-card>
        </v-dialog>

        <v-dialog
            v-model="deleteDialog"
            persistent
            max-width="300"
        >
            <v-card>
                <v-card-title class="headline primary white--text">
                    {{ $t('delete_', [$tc('coupon', 1)]) }}
                </v-card-title>

                <v-card-text class="pt-2">
                    <p class="mb-2">{{ $t('coupon_del_desc_1') }}</p>
                    <p>{{ $t('coupon_del_desc_2') }}</p>
                </v-card-text>

                <v-card-actions class="justify-center">
                    <v-btn
                        :loading="loading"
                        @click="closeDeleteDialog"
                        color="primary"
                        text
                    >
                        {{ $t('no') }}
                    </v-btn>

                    <v-btn
                        :loading="loading"
                        @click="deleteCoupon"
                        color="primary"
                        text
                    >
                        {{ $t('yes') }}
                    </v-btn>
                </v-card-actions>
            </v-card>
        </v-dialog>
    </v-row>
</template>

<script>
    import DataTable from "../DataTable";
    import CouponCreateForm from "./CouponCreateForm";
    import { mapMutations } from "vuex";
    import CouponEditForm from "./CouponEditForm";

    export default {
        name: 'Coupon',
        components: {
            CouponEditForm,
            CouponCreateForm,
            DataTable
        },
        data: () => ({
            loading: false,
            items: [],
            createDialog: false,
            editDialog: false,
            deleteDialog: false,
            deleting: null,
            editing: null,
            forceReload: false
        }),
        computed: {
            headers() {
                return [
                    { text: this.$t('name'), value: 'name', sortable: false },
                    { text: this.$t('code'), value: 'code', sortable: false },
                    { text: this.$t('status'), value: 'enabled', sortable: false },
                    { text: this.$t('action'), value: 'actions', sortable: false },
                ]
            },
            label() {

            },
            searchLabel() {
                return this.$t('search_using', {
                    field: this.$t('coupon_', [this.$t('name')]) + this.$t('or', {field: this.$t('code')})
                })
            }
        },
        methods: {
            ...mapMutations('snackbar', [
                'success',
                'error'
            ]),
            openEditDialog(coupon) {
                this.editing = _.cloneDeep(coupon);
                this.editDialog = true;
            },
            closeEditDialog() {
                this.editDialog = false;
                this.editing = null;
            },
            openDeleteDialog(coupon) {
                this.deleting = coupon;
                this.deleteDialog = true;
            },
            closeDeleteDialog() {
                this.deleteDialog = false;
                this.deleting = null;
            },
            createCoupon(coupon) {
                this.loading = true;

                axios.post('api/coupons', coupon)
                    .then(() => {
                        this.forceReload = true;
                        this.success(this.$t('coupon_action.create'));
                        this.createDialog = false;
                    })
                    .catch(({ response }) => {
                        this.error(response.data.message);
                    })
                    .finally(() => {
                        this.loading = false;
                    })
            },
            editCoupon() {
                this.loading = true;

                axios.put(`api/coupons/${this.editing.id}`, {
                    name: this.editing.name,
                    code: this.editing.code,
                    plan_ids: this.editing.plan,
                    enabled: this.editing.enabled,
                })
                    .then(({ data }) => {
                        const index = this.items.findIndex(i => i.id === this.editing.id)
                        this.$set(this.items, index, data);
                        this.success(this.$t('coupon_action.update'));
                        this.closeEditDialog();
                    })
                    .catch(({ response }) => {
                        this.error(response.data.message);
                    })
                    .finally(() => {
                        this.loading = false;
                    })
            },
            deleteCoupon() {
                this.loading = true;

                axios.delete(`api/coupons/${this.deleting.id}`)
                    .then(() => {
                        const index = this.items.findIndex(i => i.id === this.deleting.id)
                        this.items.splice(index, 1);
                        this.success(this.$t('coupon_action.delete'));
                        this.closeDeleteDialog();
                    })
                    .catch(({ response }) => {
                        this.error(response.data.message);
                    })
                    .finally(() => {
                        this.loading = false;
                    })
            }
        }
    }
</script>

<style scoped>

</style>
